using EonaCat.LogStack.Core;
using System;
using System.Runtime.CompilerServices;

namespace EonaCat.LogStack.Boosters
{
    // This file is part of the EonaCat project(s) which is released under the Apache License.
    // See the LICENSE file or go to https://EonaCat.com/License for full license details.

    public sealed class MemoryBooster : BoosterBase
    {
        public MemoryBooster() : base("Memory") { }

        [System.Runtime.CompilerServices.MethodImpl(MethodImplOptions.AggressiveInlining)]
        public override bool Boost(ref LogEventBuilder builder)
        {
            var memoryMB = GC.GetTotalMemory(false) / 1024 / 1024;
            builder.WithProperty("Memory", memoryMB);
            return true;
        }
    }
}
